Index: setup.py
===================================================================
--- setup.py	(revision 916)
+++ setup.py	(revision 981)
@@ -5,4 +5,5 @@
 from glob import glob
 from distutils.core import setup
+from pathlib import Path
 
 scriptdir=os.path.dirname(sys.argv[0])
@@ -11,4 +12,33 @@
 import mlx.const
 import mlx.update
+
+defaultManifest="""<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
+<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0">
+  <trustInfo xmlns="urn:schemas-microsoft-com:asm.v3">
+    <security>
+      <requestedPrivileges>
+        <requestedExecutionLevel level="asInvoker"/>
+      </requestedPrivileges>
+    </security>
+  </trustInfo>
+  <compatibility xmlns="urn:schemas-microsoft-com:compatibility.v1">
+    <application>
+      <!--The ID below indicates application support for Windows Vista -->
+      <supportedOS Id="{e2011457-1546-43c5-a5fe-008deee3d3f0}"/>
+      <!--The ID below indicates application support for Windows 7 -->
+      <supportedOS Id="{35138b9a-5d96-4fbd-8e2d-a2440225f93a}"/>
+      <!--The ID below indicates application support for Windows 8 -->
+      <supportedOS Id="{4a2f28e3-53b9-4441-ba9c-d69d4a4a6e38}"/>
+      <!--The ID below indicates application support for Windows 8.1 -->
+      <supportedOS Id="{1f676c76-80e1-4239-95bb-83d0f6d0da78}"/>
+      <!--The ID below indicates application support for Windows 10 -->
+      <supportedOS Id="{8e0f7a12-bfb3-4fe8-b9a5-48fd50a15a9a}"/>
+    </application>
+  </compatibility>
+</assembly>"""
+
+adminManifest=defaultManifest.replace("asInvoker", "requireAdministrator")
+
+RT_MANIFEST=24
 
 data_files = [("sounds", glob(os.path.join("sounds", "*.*")))]
@@ -37,70 +67,133 @@
         os.environ["PATH"] = os.environ["PATH"] + ";" + glob(os.path.join(msvcrDir))[0]
 
-
     gtkRuntimeDir = os.environ["GTKRTDIR"] if "GTKRTDIR" in os.environ else None
     if gtkRuntimeDir:
-        path = os.path.join("lib", "gtk-2.0", "2.10.0", "engines")
-        data_files.append((os.path.join("library", path),
-                           [os.path.join(gtkRuntimeDir, path, "libwimp.dll")]))
-
-        path = os.path.join("share", "themes", "MS-Windows", "gtk-2.0")
-        data_files.append((os.path.join("library", path),
-                           glob(os.path.join(gtkRuntimeDir, path, "*"))))
-
-        path = os.path.join("share", "locale", "hu", "LC_MESSAGES")
-        data_files.append((os.path.join("library", path),
-                           glob(os.path.join(gtkRuntimeDir, path, "*"))))
-        path = os.path.join("share", "icons", "hicolor")
-        data_files.append((os.path.join("library", path),
-                           glob(os.path.join(gtkRuntimeDir, path, "*"))))
+        if gtkRuntimeDir.endswith("/mingw32"):
+            files = {}
+
+            for components in [ ["lib", "girepository-1.0"],
+                                ["lib", "gdk-pixbuf-2.0", "2.10.0", "loaders.cache"],
+                                ["lib", "gdk-pixbuf-2.0", "2.10.0", "loaders", "libpixbufloader-ico.dll"],
+                                ["lib", "gdk-pixbuf-2.0", "2.10.0", "loaders", "libpixbufloader-png.dll"],
+                                ["lib", "gdk-pixbuf-2.0", "2.10.0", "loaders", "libpixbufloader-svg.dll"],
+                                ["share", "icons", "Adwaita", "icon-theme.cache"],
+                                ["share", "icons", "Adwaita", "index.theme"],
+                                ["share", "icons", "Adwaita", "16x16"],
+                                ["share", "locale", "hu"],
+                                ["share", "locale", "en"],
+                                ["share", "themes"],
+                                ["share", "glib-2.0", "schemas"]]:
+                 path = os.path.join(*components)
+                 p = Path(os.path.join(gtkRuntimeDir, path))
+                 if p.is_file():
+                     d = os.path.dirname(path)
+                     if d in files:
+                         files[d].append(str(p))
+                     else:
+                         files[d] = [str(p)]
+                 else:
+                     for f in p.glob("**/*"):
+                         if f.is_file():
+                             d = os.path.join(path, str(f.parent.relative_to(p)))
+                             if d in files:
+                                 files[d].append(str(f))
+                             else:
+                                 files[d] = [str(f)]
+
+            for path in files:
+                data_files.append((path, files[path]))
+            data_files.append(("",
+                               [os.path.join(gtkRuntimeDir, "bin", "librsvg-2-2.dll"),
+                                os.path.join(gtkRuntimeDir, "bin", "libcroco-0.6-3.dll")]))
+        else:
+            path = os.path.join("lib", "gtk-2.0", "2.10.0", "engines")
+            data_files.append((os.path.join("library", path),
+                               [os.path.join(gtkRuntimeDir, path, "libwimp.dll")]))
+
+            path = os.path.join("share", "themes", "MS-Windows", "gtk-2.0")
+            data_files.append((os.path.join("library", path),
+                               glob(os.path.join(gtkRuntimeDir, path, "*"))))
+
+            path = os.path.join("share", "locale", "hu", "LC_MESSAGES")
+            data_files.append((os.path.join("library", path),
+                               glob(os.path.join(gtkRuntimeDir, path, "*"))))
+            path = os.path.join("share", "icons", "hicolor")
+            data_files.append((os.path.join("library", path),
+                               glob(os.path.join(gtkRuntimeDir, path, "*"))))
 
     cefDir = os.environ.get("CEFDIR")
     if cefDir:
-        for fileName in ["icudt.dll", "subprocess.exe"]:
+        for fileName in ["icudtl.dat", "subprocess.exe", "natives_blob.bin",
+                         "snapshot_blob.bin", "v8_context_snapshot.bin",
+                         "cef.pak", "cef_100_percent.pak",
+                         "cef_200_percent.pak", "cef_extensions.pak"]:
             data_files.append(("", [os.path.join(cefDir, fileName)]))
 
         data_files.append(("locales",
-                           glob(os.path.join(cefDir, "locales", "*"))))
+                           [os.path.join(cefDir, "locales", "hu.pak"),
+                            os.path.join(cefDir, "locales", "en-GB.pak"),
+                            os.path.join(cefDir, "locales", "en-US.pak"),
+                            os.path.join(cefDir, "locales", "ru.pak")]))
 
     if os.getenv("WINE")=="yes":
         winsysdir=os.getenv("WINSYSDIR")
-        data_files.append(("", [os.path.join(winsysdir, "python27.dll")]))
-        data_files.append(("library", [
-                            os.path.join(winsysdir, "pywintypes27.dll"),
-                            os.path.join(winsysdir, "WINHTTP.dll")]))
 
         if gtkRuntimeDir:
             gtkBinDir = os.path.join(gtkRuntimeDir, "bin")
-            data_files.append(("library", [
-                                os.path.join(gtkBinDir, "freetype6.dll"),
-                                os.path.join(gtkBinDir, "intl.dll"),
-                                os.path.join(gtkBinDir, "zlib1.dll"),
+            data_files.append(("", [
+                                os.path.join(gtkBinDir, "libatk-1.0-0.dll"),
+                                os.path.join(gtkBinDir, "libbz2-1.dll"),
+                                os.path.join(gtkBinDir, "libcairo-2.dll"),
+                                os.path.join(gtkBinDir, "libcairo-gobject-2.dll"),
+                                os.path.join(gtkBinDir, "libcroco-0.6-3.dll"),
+                                os.path.join(gtkBinDir, "libcrypto-1_1.dll"),
+                                os.path.join(gtkBinDir, "libdatrie-1.dll"),
+                                os.path.join(gtkBinDir, "libepoxy-0.dll"),
+                                os.path.join(gtkBinDir, "libexpat-1.dll"),
+                                os.path.join(gtkBinDir, "libexslt-0.dll"),
+                                os.path.join(gtkBinDir, "libffi-6.dll"),
+                                os.path.join(gtkBinDir, "libfontconfig-1.dll"),
+                                os.path.join(gtkBinDir, "libfreetype-6.dll"),
+                                os.path.join(gtkBinDir, "libfribidi-0.dll"),
+                                os.path.join(gtkBinDir, "libgcc_s_dw2-1.dll"),
+                                os.path.join(gtkBinDir, "libgdk_pixbuf-2.0-0.dll"),
+                                os.path.join(gtkBinDir, "libgio-2.0-0.dll"),
+                                os.path.join(gtkBinDir, "libgirepository-1.0-1.dll"),
                                 os.path.join(gtkBinDir, "libglib-2.0-0.dll"),
-                                os.path.join(gtkBinDir, "libatk-1.0-0.dll"),
-                                os.path.join(gtkBinDir, "libcairo-2.dll"),
-                                os.path.join(gtkBinDir, "libexpat-1.dll"),
-                                os.path.join(gtkBinDir, "libpangowin32-1.0-0.dll"),
-                                os.path.join(gtkBinDir, "libgio-2.0-0.dll"),
-                                os.path.join(gtkBinDir, "libgdk-win32-2.0-0.dll"),
-                                os.path.join(gtkBinDir, "libpng14-14.dll"),
+                                os.path.join(gtkBinDir, "libgmodule-2.0-0.dll"),
                                 os.path.join(gtkBinDir, "libgobject-2.0-0.dll"),
-                                os.path.join(gtkBinDir, "libgdk_pixbuf-2.0-0.dll"),
-                                os.path.join(gtkBinDir, "libfontconfig-1.dll"),
-                                os.path.join(gtkBinDir, "libpangoft2-1.0-0.dll"),
-                                os.path.join(gtkBinDir, "libgmodule-2.0-0.dll"),
+                                os.path.join(gtkBinDir, "libgraphite2.dll"),
+                                os.path.join(gtkBinDir, "libharfbuzz-0.dll"),
+                                os.path.join(gtkBinDir, "libiconv-2.dll"),
+                                os.path.join(gtkBinDir, "libintl-8.dll"),
+                                os.path.join(gtkBinDir, "liblzma-5.dll"),
+                                os.path.join(gtkBinDir, "libmpdec-2.dll"),
                                 os.path.join(gtkBinDir, "libpango-1.0-0.dll"),
                                 os.path.join(gtkBinDir, "libpangocairo-1.0-0.dll"),
-                                os.path.join(gtkBinDir, "libgtk-win32-2.0-0.dll"),
-                                os.path.join(gtkBinDir, "libgthread-2.0-0.dll")
+                                os.path.join(gtkBinDir, "libpangoft2-1.0-0.dll"),
+                                os.path.join(gtkBinDir, "libpangowin32-1.0-0.dll"),
+                                os.path.join(gtkBinDir, "libpcre-1.dll"),
+                                os.path.join(gtkBinDir, "libpixman-1-0.dll"),
+                                os.path.join(gtkBinDir, "libpng16-16.dll"),
+                                os.path.join(gtkBinDir, "librsvg-2-2.dll"),
+                                os.path.join(gtkBinDir, "libssl-1_1.dll"),
+                                os.path.join(gtkBinDir, "libssp-0.dll"),
+                                os.path.join(gtkBinDir, "libstdc++-6.dll"),
+                                os.path.join(gtkBinDir, "libthai-0.dll"),
+                                os.path.join(gtkBinDir, "libwinpthread-1.dll"),
+                                os.path.join(gtkBinDir, "libxml2-2.dll"),
+                                os.path.join(gtkBinDir, "libxslt-1.dll"),
+                                os.path.join(gtkBinDir, "zlib1.dll"),
                               ]))
         if cefDir:
-            data_files.append(("library", [
-                                os.path.join(cefDir, "libcef.dll")
+            data_files.append(("", [
+                                os.path.join(cefDir, "libcef.dll"),
+                                os.path.join(cefDir, "chrome_elf.dll")
                               ]))
 
-    print data_files
+    print(data_files)
 
     with open("mlx-common.nsh", "wt") as f:
-            print >>f, '!define MLX_VERSION "%s"' % (mlx.const.VERSION)
+            print('!define MLX_VERSION "%s"' % (mlx.const.VERSION), file=f)
             f.close()
 else:
@@ -129,10 +222,11 @@
       requires = ["pyuipc", "xplra"],
       windows = [{ "script" : "runmlx.py",
-                   "icon_resources" : [(1, "logo.ico")]},
+                   "icon_resources" : [(1, "logo.ico")],
+                   "other_resources": [(RT_MANIFEST, 1, defaultManifest)]},
                  { "script" : "mlxupdate.py",
-                   "uac_info" : "requireAdministrator"}],
-      options = { "py2exe" : { "includes": "gio, pango, atk, pangocairo, lxml._elementpath",
+                   "other_resources": [(RT_MANIFEST, 1, adminManifest)]}],
+      options = { "py2exe" : { "packages" : "gi, lxml",
                                "skip_archive": True} },
-      zipfile = "library/.",
+      zipfile = "library",
       data_files = data_files,
       platforms = ["Win32", "Linux"],
@@ -141,8 +235,6 @@
 
 if os.name=="nt":
-    os.rename(os.path.join(scriptdir, "dist", "library", "libcef.dll"),
-              os.path.join(scriptdir, "dist", "libcef.dll"))
     mlx.update.buildManifest(os.path.join(scriptdir, "dist"))
     with open(os.path.join(scriptdir, "dist", "Uninstall.conf"), "wt") as f:
-        print >> f, "StartMenuFolder=MAVA Logger X"
-        print >> f, "LinkName=MAVA Logger X"
+        print("StartMenuFolder=MAVA Logger X", file=f)
+        print("LinkName=MAVA Logger X", file=f)
Index: src/mlx/acars.py
===================================================================
--- src/mlx/acars.py	(revision 743)
+++ src/mlx/acars.py	(revision 919)
@@ -1,4 +1,4 @@
 
-import const
+from . import const
 
 #------------------------------------------------------------------------------
Index: src/mlx/acft.py
===================================================================
--- src/mlx/acft.py	(revision 905)
+++ src/mlx/acft.py	(revision 919)
@@ -1,9 +1,9 @@
 
-import const
-import gates
-import checks
-import fs
-from i18n import xstr
-import util
+from . import const
+from . import gates
+from . import checks
+from . import fs
+from .i18n import xstr
+from . import util
 
 import sys
@@ -308,5 +308,5 @@
               ("-" if value is None else "enabled" if value else "disabled",)
         elif dt!=DERATE_NONE:
-            print "mlx.acft.getDerateLine: invalid derate type: " + dt
+            print("mlx.acft.getDerateLine: invalid derate type: " + dt)
 
         return None
@@ -343,5 +343,5 @@
                                   self._aircraftState, aircraftState)
                 except:
-                    print >> sys.stderr, "Checker", checker, "failed"
+                    print("Checker", checker, "failed", file=sys.stderr)
                     traceback.print_exc()
 
@@ -351,5 +351,5 @@
             self._minVS = min(self._minVS, aircraftState.vs)
         except:
-            print >> sys.stderr, "Failed to handle the state"
+            print("Failed to handle the state", file=sys.stderr)
             traceback.print_exc()
         finally:
@@ -403,5 +403,5 @@
                     self._logQNH(aircraftState)
             elif newStage==const.STAGE_GOAROUND:
-                from logger import Logger
+                from .logger import Logger
                 self._flight.handleFault("goaround",
                                          aircraftState.timestamp,
@@ -1284,47 +1284,47 @@
     value = SmoothedValue()
 
-    print "Adding 1, 12.0"
+    print("Adding 1, 12.0")
     value.add(1, 12.0)
-    print value.get()
-
-    print "Adding 1, 15.0"
+    print(value.get())
+
+    print("Adding 1, 15.0")
     value.add(1, 15.0)
-    print value.get()
-
-    print "Adding 2, 18.0"
+    print(value.get())
+
+    print("Adding 2, 18.0")
     value.add(2, 18.0)
-    print value.get()
-
-    print "Adding 2, 20.0"
+    print(value.get())
+
+    print("Adding 2, 20.0")
     value.add(2, 20.0)
-    print value.get()
-
-    print "Adding 5, 22.0"
+    print(value.get())
+
+    print("Adding 5, 22.0")
     value.add(5, 22.0)
-    print value.get()
-
-    print "Adding 5, 25.0"
+    print(value.get())
+
+    print("Adding 5, 25.0")
     value.add(5, 25.0)
-    print value.get()
-
-    print "Adding 5, 29.0"
+    print(value.get())
+
+    print("Adding 5, 29.0")
     value.add(5, 29.0)
-    print value.get()
-
-    print "Adding 5, 21.0"
+    print(value.get())
+
+    print("Adding 5, 21.0")
     value.add(5, 21.0)
-    print value.get()
-
-    print "Adding 5, 26.0"
+    print(value.get())
+
+    print("Adding 5, 26.0")
     value.add(5, 26.0)
-    print value.get()
-
-    print "Adding 2, 30.0"
+    print(value.get())
+
+    print("Adding 2, 30.0")
     value.add(2, 30.0)
-    print value.get()
-
-    print "Adding 2, 55.0"
+    print(value.get())
+
+    print("Adding 2, 55.0")
     value.add(2, 55.0)
-    print value.get()
-
-#---------------------------------------------------------------------------------------
+    print(value.get())
+
+#---------------------------------------------------------------------------------------
Index: src/mlx/airports.py
===================================================================
--- src/mlx/airports.py	(revision 325)
+++ src/mlx/airports.py	(revision 919)
@@ -88,11 +88,11 @@
 
 if __name__ == "__main__":
-    for (town, airport) in airportNames.itervalues():
-        print town, airport
-    print getWelcomeMessage("LIRF")
-    print getWelcomeMessage("LHDC")
-    print getWelcomeMessage("LIRN")
-    print getWelcomeMessage("LHBP")
-    print getWelcomeMessage("EDDF")
+    for (town, airport) in airportNames.values():
+        print(town, airport)
+    print(getWelcomeMessage("LIRF"))
+    print(getWelcomeMessage("LHDC"))
+    print(getWelcomeMessage("LIRN"))
+    print(getWelcomeMessage("LHBP"))
+    print(getWelcomeMessage("EDDF"))
 
 #-----------------------------------------------------------------------------
Index: src/mlx/checks.py
===================================================================
--- src/mlx/checks.py	(revision 912)
+++ src/mlx/checks.py	(revision 919)
@@ -1,8 +1,8 @@
 
-import fs
-import const
-import util
-from acars import ACARS
-from sound import startSound
+from . import fs
+from . import const
+from . import util
+from .acars import ACARS
+from .sound import startSound
 
 import time
@@ -129,9 +129,9 @@
         """Callback for ACARS sending."""
         if returned:
-            print "Sent online ACARS"
+            print("Sent online ACARS")
             self._lastSent = time.time() if self._lastSent is None \
                              else self._lastSent + ACARSSender.INTERVAL
         else:
-            print "Failed to send the ACARS"
+            print("Failed to send the ACARS")
         self._sending = False
 
@@ -517,6 +517,6 @@
     def getMessage(logName, frequency, obs):
         """Get the message for the given NAV radio setting."""
-        message = u"%-5s %s" % (logName + ":", frequency)
-        if obs is not None: message += u" (%03d\u00b0)" % (obs,)
+        message = "%-5s %s" % (logName + ":", frequency)
+        if obs is not None: message += " (%03d\u00b0)" % (obs,)
         return message
 
@@ -747,7 +747,7 @@
         message = what
         if value is None:
-            message += u" cannot be detected, will not log"
+            message += " cannot be detected, will not log"
         else:
-            message += u": " + format % (value,)
+            message += ": " + format % (value,)
         logger.message(timestamp, message)
 
@@ -767,6 +767,6 @@
     def _logAPHeading(logger, timestamp, state):
         """Log the AP heading."""
-        APLogger._logNumeric(logger, timestamp, u"AP heading",
-                             u"%03.0f\u00b0", state.apHeading)
+        APLogger._logNumeric(logger, timestamp, "AP heading",
+                             "%03.0f\u00b0", state.apHeading)
 
     @staticmethod
@@ -779,6 +779,6 @@
     def _logAPAltitude(logger, timestamp, state):
         """Log the AP heading."""
-        APLogger._logNumeric(logger, timestamp, u"AP altitude",
-                             u"%.0f ft", state.apAltitude)
+        APLogger._logNumeric(logger, timestamp, "AP altitude",
+                             "%.0f ft", state.apAltitude)
 
     def __init__(self):
Index: src/mlx/common.py
===================================================================
--- src/mlx/common.py	(revision 800)
+++ src/mlx/common.py	(revision 995)
@@ -7,13 +7,4 @@
 # Common definitions to be used by both the GUI and possible other parts
 #
-# The main purpose of this module is to import Gtk+2 or 3 and related modules
-# and provide common names for them. There is a similator module in the GUI
-# part (\ref mlx.gui.common), which contains the GUI-specific names. This one
-# contains only what is used by other modules as well.
-# The variable \c pygobject tells which version of Gtk is being used. If it is
-# \c True, Gtk+ 3 is used via the PyGObject interface. Otherwise Gtk+ 2 is
-# used, which is the default on Windows or when the \c FORCE_PYGTK environment
-# variable is set.
-
 #---------------------------------------------------------------------------------------
 
@@ -22,12 +13,33 @@
 #-------------------------------------------------------------------------------
 
-# Due to CEF, PyGTK is the default
-if "FORCE_PYGOBJECT" not in os.environ:
-    print "Using PyGTK"
-    pygobject = False
-    import gobject
-else:
-    print "Using PyGObject"
-    pygobject = True
+from gi.repository import GObject
 
-    from gi.repository import GObject as gobject
+#-------------------------------------------------------------------------------
+
+def fixUnpickledValue(value):
+    """Fix the given unpickled value.
+
+    It handles some basic data, like scalars, lists and tuples. If it
+    encounters byte arrays, they are decoded as 'utf-8' strings."""
+    if isinstance(value, bytes):
+        return str(value, "utf-8")
+    elif isinstance(value, list):
+        return [fixUnpickledValue(v) for v in value]
+    elif isinstance(value, tuple):
+        return tuple([fixUnpickledValue(v) for v in value])
+    else:
+        return value
+
+#-------------------------------------------------------------------------------
+
+def fixUnpickled(state):
+    """Fix the given unpickled state.
+
+    It checks keys and values, and if it encounters any byte arrays, they are
+    decoded with the encoding 'utf-8'. It returns a new dictionary.
+    """
+    newDict = {}
+    for (key, value) in iter(state.items()):
+        newDict[fixUnpickledValue(key)] = fixUnpickledValue(value)
+
+    return newDict
Index: src/mlx/config.py
===================================================================
--- src/mlx/config.py	(revision 738)
+++ src/mlx/config.py	(revision 1011)
@@ -1,11 +1,11 @@
 # -*- encoding: utf-8 -*-
 
-import const
-from util import secondaryInstallation, utf2unicode
+from . import const
+from .util import secondaryInstallation, utf2unicode
 
 import os
 import sys
 import traceback
-import ConfigParser
+import configparser
 
 ## @package mlx.config
@@ -163,5 +163,5 @@
         baseName = "callouts." + const.icaoCodes[aircraftType] + "."
         index = 0
-        for (altitude, path) in self._mapping.iteritems():
+        for (altitude, path) in self._mapping.items():
             option = baseName + str(index)
             config.set(ApproachCallouts.SECTION, option,
@@ -171,9 +171,9 @@
     def getAltitudes(self, descending = True):
         """Get the altitudes in decreasing order by default."""
-        altitudes = self._mapping.keys()
+        altitudes = list(self._mapping.keys())
         altitudes.sort(reverse = descending)
         return altitudes
 
-    def __nonzero__(self):
+    def __bool__(self):
         """Return if there is anything in the mapping."""
         return not not self._mapping
@@ -211,5 +211,5 @@
 class Config(object):
     """Our configuration."""
-    DEFAULT_UPDATE_URL = "http://mlx.varadiistvan.hu/update"
+    DEFAULT_UPDATE_URL = "https://mlx.varadiistvan.hu/update"
 
     _messageTypesSection = "messageTypes"
@@ -258,4 +258,5 @@
         if secondaryInstallation:
             self._updateURL += "/exp"
+        self._updateURLUpdated = True
         self._useRPC = True
 
@@ -703,6 +704,8 @@
     def load(self):
         """Load the configuration from its default location."""
+        self._updateURLUpdated = False
+
         try:
-            config = ConfigParser.RawConfigParser()
+            config = configparser.RawConfigParser()
             config.read(configPath)
         except:
@@ -788,4 +791,10 @@
                                     Config.DEFAULT_UPDATE_URL +
                                     ("/exp" if secondaryInstallation else ""))
+        self._updateURLUpdated = self._getBoolean(config, "update",
+                                                  "urlUpdated", False)
+        if self._updateURL.startswith("http://") and not self._updateURLUpdated:
+            self._updateURL = "https://" + self._updateURL[7:]
+            self._updateURLUpdated = True
+
         self._useRPC = self._getBoolean(config, "general", "useRPC", True)
 
@@ -806,5 +815,5 @@
             return
 
-        config = ConfigParser.RawConfigParser()
+        config = configparser.RawConfigParser()
 
         config.add_section("login")
@@ -880,4 +889,5 @@
                    "yes" if self._autoUpdate else "no")
         config.set("update", "url", self._updateURL)
+        config.set("update", "urlUpdated", self._updateURLUpdated)
 
         config.set("general", "useRPC",
@@ -892,15 +902,15 @@
         try:
             fd = os.open(configPath, os.O_CREAT|os.O_TRUNC|os.O_WRONLY,
-                         0600)
+                         0o600)
             with os.fdopen(fd, "wt") as f:
                 config.write(f)
             self._modified = False
 
-            print "Configuration saved:"
+            print("Configuration saved:")
             self.log()
 
-        except Exception, e:
-            print >> sys.stderr, "Failed to update config: " + \
-                                 utf2unicode(str(e))
+        except Exception as e:
+            print("Failed to update config: " + \
+                                 utf2unicode(str(e)), file=sys.stderr)
 
     def _getBoolean(self, config, section, option, default):
@@ -945,5 +955,5 @@
         import locale
         if self._language:
-            print "Setting up locale for", self._language
+            print("Setting up locale for", self._language)
             os.environ["LANGUAGE"] = self._language
             langAndEncoding = self._language + "." + locale.getpreferredencoding()
@@ -978,62 +988,63 @@
     def log(self):
         """Log the configuration by printing the values"""
-        print "  pilot ID:", self._pilotID
-        print "  rememberPassword:", self._rememberPassword
-
-        print "  language:", self._language
-
-        print "  hideMinimizedWindow:", self._hideMinimizedWindow
-        print "  quitOnClose:", self._quitOnClose
-
-        print "  onlineGateSystem:", self._onlineGateSystem
-        print "  onlineACARS:", self._onlineACARS
-
-        print "  flareTimeFromFS:", self._flareTimeFromFS
-        print "  syncFSTime:", self._syncFSTime
-        print "  usingFS2Crew:", self._usingFS2Crew
-
-        print "  iasSmoothingLength:", self._iasSmoothingLength
-        print "  vsSmoothingLength:", self._vsSmoothingLength
-
-        print "  useSimBrief:", self._useSimBrief
-        print "  simBriefUserName:", self._simBriefUserName
-        print "  rememberSimBriefPassword:", self._rememberSimBriefPassword
-
-        print "  pirepDirectory:", self._pirepDirectory
-        print "  pirepAutoSave:", self._pirepAutoSave
-
-        print "  defaultMSFS:", self._defaultMSFS
-
-        print "  enableSounds:", self._enableSounds
-
-        print "  pilotControlsSounds:", self._pilotControlsSounds
-        print "  pilotHotkey:", str(self._pilotHotkey)
-
-        print "  enableApproachCallouts:", self._enableApproachCallouts
-        print "  speedbrakeAtTD:", self._speedbrakeAtTD
-
-        print "  enableChecklists:", self._enableChecklists
-        print "  checklistHotkey:", str(self._checklistHotkey)
-
-        print "  autoUpdate:", self._autoUpdate
-        print "  updateURL:", self._updateURL
-        print "  useRPC:", self._useRPC
-
-        print "  messageTypeLevels:"
-        for (type, level) in self._messageTypeLevels.iteritems():
-            print "    %s: %s" % (const.messageType2string(type),
-                                  const.messageLevel2string(level))
-
-        print "  checklists:"
-        for (type, checklist) in self._checklists.iteritems():
-            print "    %s:" % (const.icaoCodes[type],)
+        print("  pilot ID:", self._pilotID)
+        print("  rememberPassword:", self._rememberPassword)
+
+        print("  language:", self._language)
+
+        print("  hideMinimizedWindow:", self._hideMinimizedWindow)
+        print("  quitOnClose:", self._quitOnClose)
+
+        print("  onlineGateSystem:", self._onlineGateSystem)
+        print("  onlineACARS:", self._onlineACARS)
+
+        print("  flareTimeFromFS:", self._flareTimeFromFS)
+        print("  syncFSTime:", self._syncFSTime)
+        print("  usingFS2Crew:", self._usingFS2Crew)
+
+        print("  iasSmoothingLength:", self._iasSmoothingLength)
+        print("  vsSmoothingLength:", self._vsSmoothingLength)
+
+        print("  useSimBrief:", self._useSimBrief)
+        print("  simBriefUserName:", self._simBriefUserName)
+        print("  rememberSimBriefPassword:", self._rememberSimBriefPassword)
+
+        print("  pirepDirectory:", self._pirepDirectory)
+        print("  pirepAutoSave:", self._pirepAutoSave)
+
+        print("  defaultMSFS:", self._defaultMSFS)
+
+        print("  enableSounds:", self._enableSounds)
+
+        print("  pilotControlsSounds:", self._pilotControlsSounds)
+        print("  pilotHotkey:", str(self._pilotHotkey))
+
+        print("  enableApproachCallouts:", self._enableApproachCallouts)
+        print("  speedbrakeAtTD:", self._speedbrakeAtTD)
+
+        print("  enableChecklists:", self._enableChecklists)
+        print("  checklistHotkey:", str(self._checklistHotkey))
+
+        print("  autoUpdate:", self._autoUpdate)
+        print("  updateURL:", self._updateURL)
+        print("  updateURLUpdated:", self._updateURLUpdated)
+        print("  useRPC:", self._useRPC)
+
+        print("  messageTypeLevels:")
+        for (type, level) in self._messageTypeLevels.items():
+            print("    %s: %s" % (const.messageType2string(type),
+                                  const.messageLevel2string(level)))
+
+        print("  checklists:")
+        for (type, checklist) in self._checklists.items():
+            print("    %s:" % (const.icaoCodes[type],))
             for path in checklist:
-                print "      " + path
-
-        print "  approachCallouts:"
-        for (type, approachCallouts) in self._approachCallouts.iteritems():
-            print "    %s:" % (const.icaoCodes[type],)
+                print("      " + path)
+
+        print("  approachCallouts:")
+        for (type, approachCallouts) in self._approachCallouts.items():
+            print("    %s:" % (const.icaoCodes[type],))
             for (altitude, path) in approachCallouts:
-                print "      %d: %s" % (altitude, path)
+                print("      %d: %s" % (altitude, path))
 
 #-------------------------------------------------------------------------------
